<?php
/**
 * This file is part of TheCartPress-csvloader.
 * 
 * TheCartPress-csvloader is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TheCartPress-csvloader is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TheCartPress-csvloader.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * NOTICES
 * -------
 * Since 1.0.9: the tax should be an index, not the real tax rate.
 */
if ( ! session_id() ) session_start();
$post_type	= isset( $_REQUEST['post_type'] ) ? $_REQUEST['post_type'] : 'tcp_product';
$separator	= isset( $_REQUEST['separator'] ) ? $_REQUEST['separator'] : '|';
//$enclosure	= isset( $_REQUEST['enclosure'] ) ? $_REQUEST['enclosure'] : '"';
$titeled	= isset( $_REQUEST['titeled'] );
$taxonomy	= isset( $_REQUEST['taxonomy'] ) ? $_REQUEST['taxonomy'] : 'tcp_product_category';
$cat		= isset( $_REQUEST['tcp_cat'] ) ? $_REQUEST['tcp_cat'] : '';
$tcp_status	= isset( $_REQUEST['tcp_status'] ) ? $_REQUEST['tcp_status'] : '';
$data	= array();
$titles	= array();
if ( isset( $_REQUEST['tcp_load_csv'] ) && isset( $_FILES['upload_file'] ) ) {
	if ( ( $handle = fopen( $_FILES['upload_file']['tmp_name'], 'r' ) ) !== FALSE ) {
		while ( ( $line = fgetcsv($handle, 1024, $separator ) ) !== FALSE )
			$data[] = $line;
		fclose( $handle );
		if ( $titeled ) {
			$titles = $data[0];
			unset( $data[0] );
		} else {
			for( $i = 0; $i < count( $data[0] ); $i++ )
				$titles[] = 'col_' . $i;
		}
	}
	$_SESSION['tcp_csv_titles'] = $titles;
	$_SESSION['tcp_csv_data'] = $data;
} elseif ( isset( $_REQUEST['tcp_load_products_from_csv'] ) && isset( $_SESSION['tcp_csv_titles'] ) ) {
	$titles = $_SESSION['tcp_csv_titles'];
	$data = $_SESSION['tcp_csv_data'];
	unset( $_SESSION['tcp_csv_titles'] );
	unset( $_SESSION['tcp_csv_data'] );
	if ( is_array( $data ) ) {
		$custom_field_defs = tcp_get_custom_fields_def( $post_type );
		$taxonomies = get_object_taxonomies( $post_type );
		$count = 0;
		$i = 0;
		foreach( $data as $cols ) {
			$i++;
			$name = '';
			$content = '';
			$excerpt = '';
			$price = 0;
			$order = '';
			$weight = 0;
			$sku = '';
			$stock = -1;
			$tax = 0;
			$attachments = array();
			$thumbnail = '';
			$custom_values = array();
			$taxo_values = array();
			foreach( $cols as $i => $col ) {
				$col_name = isset( $_REQUEST['col_' . $i] ) ? $_REQUEST['col_' . $i] : '';
				if ( $col_name == 'tcp_name' ) {
					$name = $col;
				} elseif ( $col_name == 'tcp_content' ) {
					$content = $col;
				} elseif ( $col_name == 'tcp_excerpt' ) {
					$excerpt = $col;
				} elseif ( $col_name == 'tcp_price' ) {
					$price = tcp_csv_getPrice( $col );
				} elseif ( $col_name == 'tcp_order' ) {
					$order = $col;
				} elseif ( $col_name == 'tcp_weight' ) {
					$weight = (float)$col;
				} elseif ( $col_name == 'tcp_sku' ) {
					$sku = $col;
				} elseif ( $col_name == 'tcp_stock' ) {
					$stock = (int)$col;
				} elseif ( $col_name == 'tcp_tax' ) {
					$tax = (int)$col;
				} elseif ( $col_name == 'tcp_attachment' ) {
					$attachments[] = $col;
				} elseif ( $col_name == 'tcp_thumbnail' ) {
					$thumbnail = $col;
				} else {
					$break = false;
					if ( is_array( $custom_field_defs ) && count( $custom_field_defs ) > 0 ) {
						foreach( $custom_field_defs as $custom_field_def ) {
							if ( $col_name == $custom_field_def['id'] ) {
								$custom_values[$col_name] = $col;
								$break = true;
								break;
							}
						}
					}
					if ( ! $break && is_array( $taxonomies ) && count( $taxonomies ) > 0 ) {
						foreach( $taxonomies as $taxmy ) {
							if ( $col_name == 'tcp_tax_' . $taxmy ) {
								$taxo_values[$taxmy] = $col;
								$break = true;
								break;
							}
						}
					}
				}
			}
			$post = array(
				'comment_status'=> 'closed',
				'post_content'	=> $content,
				'post_excerpt'	=> $excerpt,
				'post_status'	=> $tcp_status,
				'post_title'	=> $name,
				'post_type'		=> $post_type,
			);
			$post_id = wp_insert_post( $post );
			if ( $cat > 0 ) {
				wp_set_object_terms( $post_id, (int)$cat, $taxonomy, false );
			}
			update_post_meta( $post_id, 'tcp_tax_id', $tax );
			update_post_meta( $post_id, 'tcp_is_visible', true );
			update_post_meta( $post_id, 'tcp_is_downloadable', false );
			update_post_meta( $post_id, 'tcp_max_downloads', 0 );
			update_post_meta( $post_id, 'tcp_days_to_expire', 0 );
			update_post_meta( $post_id, 'tcp_type', 'SIMPLE' );
			update_post_meta( $post_id, 'tcp_price', $price );
			update_post_meta( $post_id, 'tcp_weight', $weight );
			update_post_meta( $post_id, 'tcp_order', $order );
			update_post_meta( $post_id, 'tcp_sku', $sku );
			update_post_meta( $post_id, 'tcp_stock', $stock );
			foreach( $custom_values as $id => $custom_value ) {
				update_post_meta( $post_id, $id, $custom_value );
			}
			foreach( $taxo_values as $tax => $term ) {
				$new_term = term_exists( $term, $tax );
				if ( ! is_array( $new_term ) )
					$new_term = wp_insert_term(	$term, $tax, array( 'slug' => 'tcp_' . $term ) );
				wp_set_object_terms( $post_id, (int)$new_term['term_id'], $tax, true );
			}
			foreach( $attachments as $url ) {
				//$url = urldecode( $url );
				$base = basename( $url );
				$path = wp_upload_dir();
				$path = $path['path'];
				$dest = $path . '/' . $base;
				copy( $url, $dest );
				$wp_filetype = wp_check_filetype( basename( $dest ), null );
				$attachment = array(
					'post_mime_type' => $wp_filetype['type'],
					'post_title' => preg_replace('/\.[^.]+$/', '', basename( $dest ) ),
					'post_content' => '',
					'post_status' => 'inherit',
				);
				$attach_id = wp_insert_attachment( $attachment, $dest, $post_id );
				// you must first include the image.php file for the function wp_generate_attachment_metadata() to work
				require_once(ABSPATH . "wp-admin" . '/includes/image.php');
				$attach_data = wp_generate_attachment_metadata( $attach_id, $dest );
				wp_update_attachment_metadata( $attach_id,  $attach_data );
			}

			if ( strlen( $thumbnail ) > 0 ) {
				$base = basename( $thumbnail );
				$path = wp_upload_dir();
				$path = $path['path'];
				$dest = $path . '/' . $base;
				copy( $thumbnail, $dest );
				$wp_filetype = wp_check_filetype( basename( $dest ), null );
				$attachment = array(
					'post_mime_type' => $wp_filetype['type'],
					'post_title' => preg_replace('/\.[^.]+$/', '', basename( $dest ) ),
					'post_content' => '',
					'post_status' => 'inherit',
				);
				$attach_id = wp_insert_attachment( $attachment, $dest, $post_id );
				// you must first include the image.php file for the function wp_generate_attachment_metadata() to work
				require_once(ABSPATH . "wp-admin" . '/includes/image.php');
				$attach_data = wp_generate_attachment_metadata( $attach_id, $dest );
				wp_update_attachment_metadata( $attach_id,  $attach_data );
				update_post_meta( $post_id, '_thumbnail_id', $attach_id );
			}
			$count++;
		}
		?>
		<div id="message" class="updated"><p>
			<?php printf( __( '%s products have been uploaded', 'tcp_csvl' ), $count );?>
		</p></div><?php
	} else {?>
		<div id="message" class="error"><p>
			<?php _e( 'No product has been uploaded', 'tcp_csvl' );?>
		</p></div><?php
	}
}
?>
<div class="wrap">

<h2><?php echo __( 'CSV Loader', 'tcp_csvl' );?></h2>
<ul class="subsubsub">
</ul><!-- subsubsub -->

<div class="clear"></div>

<form method="post" enctype="multipart/form-data">
	<table class="form-table">
	<tbody>
	<tr valign="top">
	<th scope="row">
		<label for="post_type"><?php _e( 'Post type', 'tcp' )?>:</label>
	</th>
	<td>
		<select name="post_type" id="post_type">
		<?php foreach( tcp_get_saleable_post_types() as $pt ) :?>
			<option value="<?php echo $pt;?>"<?php selected( $post_type, $pt ); ?>><?php echo $pt;?></option>
		<?php endforeach;?>
		</select>
		<input type="submit" name="tcp_load_taxonomies" value="<?php _e( 'Load taxonomies', 'tcp' );?>" class="button-secondary"/>
	</td>
	</tr>	
	<tr valign="top">
	<th scope="row">
		<label for="taxonomy"><?php _e( 'Taxonomy', 'tcp' )?>:</label>
	</th>
	<td>
		<select name="taxonomy" id="taxonomy">
		<?php foreach( get_object_taxonomies( $post_type ) as $taxmy ) : $tax = get_taxonomy( $taxmy ); ?>
			<option value="<?php echo esc_attr( $taxmy );?>"<?php selected( $taxmy, $taxonomy ); ?>><?php echo $tax->labels->name;?></option>
		<?php endforeach;?>
		</select>
	</td>
	</tr>
	<tr valign="top">
	<th scope="row">
		<label for="separator"><?php _e( 'Separator', 'tcp_csvl' );?>:</label>
	</th>
	<td>
		<input type="text" name="separator" id="separator" value="<?php echo $separator;?>" size="2" maxlenght="4"/>
		<label for="titeled"><?php _e( 'Columns title in first line', 'tcp_csvl' );?>:</label>
		<input type="checkbox" name="titeled" id="titeled" <?php checked($titeled);?> size="2" maxlenght="4"/>
	</td>
	</tr>
<!--	<tr valign="top">
	<th>
		<label for="enclosure"><?php _e( 'Enclosure', 'tcp_csvl' );?>:</label>
	</th>
	<td>
		<input type="text" name="enclosure" id="enclosure" value="<?php echo $enclosure;?>" size="2" maxlenght="1"/>
	</td>
	</tr>-->
	<tr valign="top">
	<th scope="row">
		<label for="upload_file" value=""><?php _e( 'file', 'tcp_csvl' );?>:</label>
	</th>
	<td>
		<input type="file" name="upload_file" id="upload_file" />
	</td>
	</tr>
	</tbody>
	</table>
	<span class="submit"><input type="submit" name="tcp_load_csv" id="tcp_load_csv" value="<?php _e( 'Load', 'tcp_csvl' );?>" style="button-secondary" /></span>
	<span><?php _e( 'This action helps you to test if the file is correct. Only 4 rows will be displayed.', 'tcp_csvl' );?></span>
</form>
<?php if ( is_array( $data ) && count( $data ) > 0 ) : ?>
<p><?php _e( 'These lines are the four first products loaded from the CSV file. If you think they are correct continue with the process.', 'tcp_csvl' );?></p>
<table class="widefat fixed" cellspacing="0">
	<?php if ( is_array( $titles ) && count( $titles ) > 0 ) :?>
		<thead>
		<tr scope="col" class="manage-column"><th>&nbsp;</th>
		<?php foreach( $titles as $col ) : ?>
			<th><?php echo $col;?></th>
		<?php endforeach;?>
		</tr>
		</thead>
		<tfoot>
		<tr scope="col" class="manage-column"><th>&nbsp;</th>
		<?php foreach( $titles as $col ) : ?>
			<th><?php echo $col;?></th>
		<?php endforeach;?>
		</tr>
		</tfoot>
	<?php endif;?>
		<tbody>
		<?php foreach( $data as $i => $cols ) :
			if ( $i > 4 ) :
				break;
			else : ?>
				<tr>
					<td><?php echo  $i;?></td>
				<?php foreach( $cols as $col ) : ?>
					<td><?php echo $col;?></td>
				<?php endforeach;?>
				</tr>
			<?php endif;?>
		<?php endforeach;?>
	</tbody>
</table>
<p><?php _e( 'Assign the columns of the CSV file (left column) to the fields of the products (right column).', 'tcp_csvl' );?></p>
<form method="post">
<input type="hidden" name="post_type" value="<?php echo $post_type;?>" />
<input type="hidden" name="taxonomy" value="<?php echo $taxonomy;?>" />
<input type="hidden" name="separator" value="<?php echo isset( $_REQUEST['separator'] ) ? $_REQUEST['separator'] : '|';?>" />
<?php if ( isset( $_REQUEST['titeled'] ) ) :?>
<input type="hidden" name="titeled" value="y"/>
<?php endif;?>
<table class="widefat fixed" cellspacing="0">
<thead>
	<tr scope="col" class="manage-column">
		<th><?php _e( 'Imported columns', 'tcp_csvl' );?></th>
		<th><?php _e( 'TheCartPress columns', 'tcp_csvl' );?></th>
	</tr>
</thead>
<tfoot>
	<tr scope="col" class="manage-column">
		<th><?php _e( 'CSV columns', 'tcp_csvl' );?></th>
		<th><?php _e( 'TheCartPress columns', 'tcp_csvl' );?></th>
	</tr>
</tfoot>
<tbody>
<?php if ( is_array( $titles ) && count( $titles ) > 0 ) : ?>
	<?php foreach( $titles as $i => $col ) : ?>
		<tr>
			<td><?php echo $col;?></td>
			<td>
			<select name="col_<?php echo $i;?>">
				<option value=""><?php _e( 'None', 'tcp_csvl' );?></option>
				<option value="tcp_name" <?php selected( strtoupper( $col ), 'NAME');?>>Title (<?php _e( 'Title', 'tcp_csvl' );?>)</option>
				<option value="tcp_content" <?php selected( strtoupper( $col ), 'CONTENT');?>>Content (<?php _e( 'Content', 'tcp_csvl' );?>)</option>
				<option value="tcp_excerpt" <?php selected( strtoupper( $col ), 'EXCERPT');?>>Excerpt (<?php _e( 'Excerpt', 'tcp_csvl' );?>)</option>
				<option value="tcp_price" <?php selected( strtoupper( $col ), 'PRICE');?>>Price (<?php _e( 'Price', 'tcp_csvl' );?>)</option>
				<option value="tcp_stock" <?php selected( strtoupper( $col ), 'STOCK');?>>Stock (<?php _e( 'Stock', 'tcp_csvl' );?>)</option>
				<option value="tcp_weight" <?php selected( strtoupper( $col ), 'WEIGHT');?>>Weight (<?php _e( 'Weight', 'tcp_csvl' );?>)</option>
				<option value="tcp_sku" <?php selected( strtoupper( $col ), 'SKU');?>>SKU (<?php _e( 'SKU', 'tcp_csvl' );?>)</option>
				<option value="tcp_order" <?php selected( strtoupper( $col ), 'ORDER');?>>Order (<?php _e( 'Order', 'tcp_csvl' );?>)</option>
				<option value="tcp_tax" <?php selected( strtoupper( $col ), 'TAX');?>>Tax (<?php _e( 'Tax', 'tcp_csvl' );?>)</option>
				<option value="tcp_attachment" <?php selected( strtoupper( $col ), 'ATTACHMENT');?>>Attachment (<?php _e( 'Attachment', 'tcp_csvl' );?>)</option>
				<option value="tcp_thumbnail" <?php selected( strtoupper( $col ), 'THUMBNAIL');?>>Thumbnail (<?php _e( 'Thumbnail', 'tcp_csvl' );?>)</option>
				<?php $custom_fields_def = tcp_get_custom_fields_def( $post_type );
				if ( is_array( $custom_fields_def ) && count( $custom_fields_def ) > 0 ) :
					foreach( $custom_fields_def as $custom_field_def ) :?>
				<option value="<?php echo $custom_field_def['id'];?>">CF <?php echo $custom_field_def['label'];?></option>
					<?php endforeach;
				endif?>
				<?php foreach( get_object_taxonomies( $post_type ) as $taxmy ) : $tax = get_taxonomy( $taxmy ); ?>
				<option value="tcp_tax_<?php echo $taxmy;?>">T <?php echo $tax->labels->name;?></option>
				<?php endforeach;?>
			</select>
			</td>
		</tr>
	<?php endforeach;?>
<?php endif;?>
</tbody>
</table>
<p>
	<label for="tcp_cat"><?php _e( 'Attach this products to the Taxonomy', 'tcp_csvl' )?>:</label>
	<select id="tcp_cat" name="tcp_cat">
	<?php $terms = get_terms( $taxonomy, array( 'hide_empty' => false ) );
	if ( is_array( $terms ) && count( $terms ) ) foreach( $terms as $term ) : ?>
		<option value="<?php echo $term->term_id;?>"<?php selected( $term->term_id, $cat ); ?>><?php echo esc_attr( $term->name );?></option>
	<?php endforeach;?>
	</select>
</p>
<p>
	<label for="tcp_status"><?php _e( 'Set products status to', 'tcp_csvl' )?>:</label>
	<select id="tcp_status" name="tcp_status">
		<option value="publish"><?php _e( 'publish', 'tcp_cvsl' );?></option>
		<option value="draft"><?php _e( 'draft', 'tcp_cvsl' );?></option>
	</select>
</p>
<span class="submit">
	<input type="submit" name="tcp_load_products_from_csv" id="tcp_load_products_from_csv" value="<?php _e( 'Upload', 'tcp_csvl' );?>" class="button-primary" />
	<span><?php _e( 'This action will load the products in the eCommerce. Be patient.', 'tcp_csvl' );?></span>
</span>
</form>
<?php endif;?>
</div>
<?php
function tcp_csv_getPrice( $source ) {
	$aux = str_replace( '$', '', $source );
	return tcp_input_number( $aux );
}
?>
